#ifndef lint
static char rcs_id[] = "$Header: /home/heberlei/Development/Protection/RCS/NeXT.c,v 1.1 93/06/25 17:02:47 heberlei Exp Locker: heberlei $";
#endif

/*
 * History:
 *	6-16-93 Todd modified Wilson's original timelocal() function so
 *		the correct number of seconds are returned (at least
 *		during daylight saving time.
 */
#ifdef NeXT

#include <stdio.h>
#include <time.h>
#include <sys/time.h>

#define DAYSEC 24 * 60 * 60
#define LEAPYEARSEC 366 * 24 * 60 * 60
#define YEARSEC 365 * 24 * 60 * 60

char statearray[32];


long lrand48()

{
	return(random());
};


void lcong48(param)
unsigned short param[7];

{
	unsigned seed;
	char sb[8];
	seed = param[0] + (param[1] << 16); 
	initstate(seed, statearray, 32);
};

time_t timelocal(tm)
struct tm *tm;
{
	time_t sec, sec_try_two, sec_try_three;
	int i, year, year1, year2;
	struct tm tm_rec;

	/* figure out the GMT offset */
	sec = time((long *) 0);
	tm_rec = *localtime(&sec);
	
	year = tm->tm_year - 70;
	sec = (LEAPYEARSEC + 3 * YEARSEC) * (year / 4);
	year1 = year % 4;
	/* deal with leap year */
	if (year1 != 3)
		sec = sec + year1 * YEARSEC;
	else 
		sec = sec + 2 * YEARSEC + LEAPYEARSEC;
	/*
	 * Need to set tm_yday since it isn't set by our caller!
	 */
	tm->tm_yday = 0;
	for (i = 0; i < tm->tm_mon; i++) {
	  switch (i) {

	  case 0:   /* Jan */
	  case 2:   /* Mar */
	  case 4:   /* May */
	  case 6:   /* Jul */
	  case 7:   /* Aug */
	  case 9:   /* Oct */
	  case 11:  /* Dec */
	    tm->tm_yday += 31;
	    break;

	  case 3:   /* Apr */
	  case 5:   /* Jun */
	  case 8:   /* Sep */
	  case 10:  /* Nov */
	    tm->tm_yday += 30;
	    break;

	  case 1:   /* Feb */
	    if (year1 == 2)
	      tm->tm_yday += 29;
	    else
	      tm->tm_yday += 28;
	    break;

	  default:
	    fprintf(stderr, "error:  bad date passed to timelocal()\n");
	    exit(1);
	    break;

	  }
	}
	tm->tm_yday += tm->tm_mday - 1;

	sec = sec + tm->tm_yday * DAYSEC;
	sec = sec + tm->tm_hour * 60 * 60; 
	sec = sec + tm->tm_min * 60;
	sec = sec + tm->tm_sec;

	/* convert from local time to GMT */
	sec = sec - tm_rec.tm_gmtoff;
	/* added the next line to try an remove a timezone bug */
	tm_rec = *localtime(&sec);
	/*
	 * Now check to see if we need to make any adjustments because
	 * of the daylight saving time.  This is really a bad hack, but
	 * timelocal() is a bad function to try to implement.  I will avoid
	 * this function in the future.
	 */
	if (tm_rec.tm_hour == tm->tm_hour) {
	    /*
	     * The time appears to be correct.  Lets return it.
	     */
	    return (sec);
	}
	/*
	 * If we get this far, the hours were off.  Lets try to add an
	 * hour to see if that works.
	 */
	sec_try_two = sec - 3600;
	tm_rec = *localtime(&sec_try_two);
	if (tm_rec.tm_hour == tm->tm_hour) {
	    /*
	     * It appears this probably solved the problem.
	     */
	    return (sec_try_two);
	}
	/*
	 * Ok, lets just add an hour and return the value.
	 */
	sec_try_three = sec + 3600;
	tm_rec = *localtime(&sec_try_three);
	if (tm_rec.tm_hour == tm->tm_hour) {
	    /*
	     * It appears this probably solved the problem.
	     */
	    return (sec_try_three);
	}
	/*
	 * If we get here, we are in trouble.  Lets just return the
	 * original guess and report the error.
	 */
	fprintf (stderr, "timelocal implementation failed.\n");
	return (sec);

	/*  Old code of Wilson's
	 * if (tm_rec.tm_isdst != 0) {
	 *	sec = sec + 60 * 60;
	 * }
	 *
	 * return sec;
	 */
};

/*
main()

{	time_t i;
	struct timeval tp;
	struct timezone tzp;
	struct tm *tm;
	gettimeofday(&tp,&tzp);	
	tm = gmtime((time_t *) &tp.tv_sec);
	tzset();
	i = timelocal(tm);
	printf("%d %s",tp.tv_sec, ctime(&tp.tv_sec));
	printf("%d %s",i,ctime(&i));
};
*/

#endif
